#include <WiFi.h>
#include <HTTPClient.h>
#include <NTPClient.h>
#include <Time.h>
#include <WiFiUdp.h>

WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP);
int i=0;

#include <OneWire.h>
#include <DallasTemperature.h>
#define ONE_WIRE_BUS 22
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);
uint8_t led = 23;            // the onboard ESP8266 LED.    
                            // If you have a NodeMCU you can use the BUILTIN_LED pin
                            // (replace 2 with BUILTIN_LED)              
float t1;


// DEFINE HERE THE KNOWN NETWORKS
const char* KNOWN_SSID[] = {"bera1", "bera.", ".bera"};
const char* KNOWN_PASSWORD[] = {"**********", "*****************", "************"};
const int   KNOWN_SSID_COUNT = sizeof(KNOWN_SSID) / sizeof(KNOWN_SSID[0]); // number of known networks

int status = WL_IDLE_STATUS;
int long x=0;

#define CHAT_ID "*****************"
#define BOTtoken "******************************************" // your Bot Token (Get from Botfather)

WiFiClientSecure client;

HTTPClient http;  
int httpCode;


//Checks for new messages every 1 second.
int botRequestDelay = 350;  //10;  //1000
unsigned long lastTimeBotRan;
int sm;    
String message="";
void setup() {
  Serial.begin(115200);
  pinMode(led, OUTPUT);
  digitalWrite(led, LOW); // turn off the led (inverted logic!)
 
  sensors.begin();
  
  // Connect to Wi-Fi
  boolean wifiFound = false;
  int i, n;
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);
  Serial.println("Setup done");
  // ----------------------------------------------------------------
  // WiFi.scanNetworks will return the number of networks found
  // ----------------------------------------------------------------
  Serial.println(F("scan start"));
  int nbVisibleNetworks = WiFi.scanNetworks();
  Serial.println(F("scan done"));
  if (nbVisibleNetworks == 0) {
    Serial.println(F("no networks found. Reset to try again"));
    while (true); // no need to go further, hang in there, will auto launch the Soft WDT reset
  }

  // ----------------------------------------------------------------
  // if you arrive here at least some networks are visible
  // ----------------------------------------------------------------
  Serial.print(nbVisibleNetworks);
  Serial.println(" network(s) found");
  for (i = 0; i < nbVisibleNetworks; ++i) {
    Serial.println(WiFi.SSID(i)); // Print current SSID
    for (n = 0; n < KNOWN_SSID_COUNT; n++) { // walk through the list of known SSID and check for a match
      if (strcmp(KNOWN_SSID[n], WiFi.SSID(i).c_str())) {
        Serial.print(F("\tNot matching "));
        Serial.println(KNOWN_SSID[n]);
      } else { // we got a match
        wifiFound = true;
        break; // n is the network index we found
      }
    } // end for each known wifi SSID
    if (wifiFound) break; // break from the "for each visible network" loop
  } // end for each visible network

  if (!wifiFound) {
    Serial.println(F("no Known network identified. Reset to try again"));
    Serial.print("Restarting...");
    esp_restart();     
//    while (true); // no need to go further, hang in there, will auto launch the Soft WDT reset
  }

  Serial.print(F("\nConnecting to "));
  Serial.println(KNOWN_SSID[n]);

  WiFi.begin(KNOWN_SSID[n], KNOWN_PASSWORD[n]);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    int f=f+1;
    Serial.print ( "." );
    if(f>60){    
          Serial.print("Restarting...");
esp_restart();    
    }
    Serial.print(".");
  }
  Serial.println("");
  Serial.println(F("WiFi connected, your IP address is "));
  Serial.println(WiFi.localIP());
  // Print ESP32 Local IP Address
  Serial.println(WiFi.localIP());

 timeClient.begin();

  
}


String getReadings(){
sensors.requestTemperatures(); // Send the command to get temperatures
float t1, humidity;
t1 = sensors.getTempCByIndex(0);
int t2=t1*100;
 timeClient.update();
String st1=timeClient.getFormattedTime();
//Serial.print("Time string value:");
//Serial.println(st1);

setTime(timeClient.getEpochTime()+5.5*3600);  //Add 5 hrs 30 minutes to IST
time_t t = now(); //Set the time;

char data1[30];
sprintf((char*)data1, "%02d/%02d/%02d,%02d:%02d:%02d",day(t),month(t),year(t),hour(t),minute(t),second(t) );
//Serial.println(data1);
message =String(data1)+",0746,0876,3278,3563,2795,"+String(t2);
x=x+1;

//Serial.println(message);
return message;
}

void loop() {
String poststr="https://api.telegram.org/bot";
poststr +=BOTtoken;
poststr +="/sendMessage?chat_id=";
poststr +=CHAT_ID;
poststr +="&text=";
poststr +=getReadings();

//Serial.println(poststr);

http.begin(poststr);
 int  httpCode=http.GET();
      if (httpCode > 0) { //Check for the returning code
        String payload = http.getString();
         Serial.print( getReadings() );
         Serial.println(" Uploaded to bera_esp32");
         digitalWrite(led,HIGH);
      }
    else {
      Serial.println("Error on HTTP request");
     esp_restart();    
    }
digitalWrite(led,LOW);



}
